package ru.ifmo.qbeing;

import ru.ifmo.qbeing.global.GlobalStrategy;
import universum.bi.BeingInterface;

public class StrategyAutomata {
    private int state;
    private GlobalStrategy strategy;
    private StateMachineContext context;

    public StrategyAutomata(GlobalStrategy strategy) {
        state = StrategyState.S_EXPLORING;
        this.strategy = strategy;
    }

    public void processStrategyEvent(int event, StateMachineContext context) {
        this.context = context;
        switch (state) {
            case StrategyState.S_EXPLORING:
                switch (event) {
                    case StrategyEvent.E200:
                        z200();
                        break;
                    case StrategyEvent.E201:
                        z201();
                        break;
                    case StrategyEvent.E202:
                        z202();
                        break;
                }
                break;
        }
    }

    private void z202() {
        strategy.beingDead(context.getBeing());
    }

    /**
     * Make calculations before each move
     */
    private void z200() {
        strategy.checkStep(context.getBeingInterface());
    }

    /**
     * Advise being state
     */
    private void z201() {
        QBeing me = context.getSender();
        BeingInterface bi = context.getBeingInterface();
        strategy.setInitialState(me, bi);
        strategy.incBeingCount();
    }
}
